/*
 * lxcall.h
 * Copyright (C) 2011-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxcall_H__
#define __LIBx1f4_lxcall_H__

#include <ct.h>
#include <dt.h>
#include <e4.h>
#include <frame.h>
#include <it.h>
#include <nt.h>
#include <track.h>
#include <trans.h>

#define u_case_args_____0 \
    const void *, struct x1f4_linetext_type *, void **
#define u_case_args_____1 \
    const void *screen, struct x1f4_linetext_type *linetext_data, void **args
#define u_case_args_____2 \
    screen, linetext_data, args

#define v_case_args_____0 \
    const void *, const struct x1f4_nodetype_type *,			      \
    struct x1f4_linetext_type *, void **
#define v_case_args_____1 \
    const void *screen, const struct x1f4_nodetype_type *nodetype_data,	      \
    struct x1f4_linetext_type *linetext_data, void **args
#define v_case_args_____2 \
    screen, nodetype_data, linetext_data, args

typedef struct line_type {
    struct x1f4_function_type function;
    void (*line) (u_case_args_____0);
} line_type;

typedef struct link_type {
    struct x1f4_function_type function;
    void (*line) (v_case_args_____0);
} link_type;

typedef struct qssc_type {
    struct x1f4_variable_type variable;
    const void *data;
} qssc_type;

typedef struct tide_type {
    struct x1f4_2ndscope_type tidespan;
    struct x1f4_operator_type operator;
} tide_type;

extern int _libx1f4i0_lxcall_even_list
    (const struct x1f4_function_type *, const struct x1f4_function_type *,
     unsigned, void ***, struct x1f4_trans_type *, struct x1f4_iturn_type *,
     struct x1f4_cturn_type *, struct x1f4_track_type *,
     const struct x1f4_eelookup_type *);
extern int _libx1f4i0_lxcall_land_node
    (struct x1f4_frame_type *, struct x1f4_track_type *,
     struct x1f4_nodetype_type *, void *, void *);
extern int _libx1f4i0_lxcall_land_slip(int, int);
extern int _libx1f4i0_lxcall_land_text
    (struct x1f4_trans_type *, struct x1f4_track_type *, const char *,
     unsigned, void *);
extern int _libx1f4i0_lxcall_line_node
    (struct x1f4_frame_type *, struct x1f4_track_type *,
     struct x1f4_datatype_type *, void *);
extern int _libx1f4i0_lxcall_line_side
    (void *, void *, const struct x1f4_operator_type *, const char *const *,
     unsigned);
extern int _libx1f4i0_lxcall_line_text
    (struct x1f4_frame_type *, struct x1f4_trans_type *,
     struct x1f4_track_type *, void *);
extern int _libx1f4i0_lxcall_line_type
    (const char **, int, const struct x1f4_eelookup_type *,
     struct trans_type *);
extern int _libx1f4i0_lxcall_lock_call
    (const struct x1f4_function_type *, unsigned, struct x1f4_trans_type *,
     struct x1f4_track_type *, struct x1f4_linetext_type **);
extern int _libx1f4i0_lxcall_miss_line
    (void *, unsigned, void *, struct qssc_type *, struct x1f4_linetext_type *,
     unsigned);
extern int _libx1f4i0_lxcall_near_node
    (struct x1f4_frame_type *, struct x1f4_track_type *,
     struct x1f4_datatype_type *, void *);
extern int _libx1f4i0_lxcall_part_text
    (struct x1f4_frame_type *, struct x1f4_track_type *, const char *,
     unsigned, void *);
extern int _libx1f4i0_lxcall_pick_call
    (void **, const struct x1f4_function_type *, unsigned,
     struct x1f4_trans_type *, struct x1f4_track_type *,
     struct x1f4_linetext_type **);
extern int _libx1f4i0_lxcall_pick_deck
    (struct x1f4_frame_type *, struct x1f4_track_type *,
     int (*) (void *, void **), int (*) (void *, void **), void *, void *,
     void *);
extern int _libx1f4i0_lxcall_pick_node
    (struct x1f4_frame_type *, struct x1f4_track_type *,
     struct x1f4_nodetype_type *, void *, void *);
extern int _libx1f4i0_lxcall_pick_text
    (struct x1f4_frame_type *, struct x1f4_trans_type *,
     struct x1f4_track_type *, void *);
extern int _libx1f4i0_lxcall_post_call
    (struct x1f4_linetext_type *, const struct x1f4_function_type *,
     void *, unsigned, void **, struct x1f4_trans_type *,
     struct x1f4_iturn_type *, struct x1f4_cturn_type *,
     struct x1f4_track_type *, const struct x1f4_eelookup_type *);
extern int _libx1f4i0_lxcall_post_node
    (struct x1f4_frame_type *, struct x1f4_track_type *,
     struct x1f4_nodetype_type *, const void *, void *);
extern int _libx1f4i0_lxcall_post_text
    (struct x1f4_frame_type *, struct x1f4_trans_type *,
     struct x1f4_track_type *, void *, void *);
extern int _libx1f4i0_lxcall_push_line
    (void *, unsigned, const void *, struct x1f4_linetext_type **,
     const struct x1f4_nodetype_type *, void **, void **, unsigned,
     const struct link_type *);
extern int _libx1f4i0_lxcall_push_text
    (struct x1f4_frame_type *, struct x1f4_track_type *, void *, void *);
extern int _libx1f4i0_lxcall_rule_list
    (const struct x1f4_function_type *, const struct x1f4_function_type *,
     unsigned, unsigned, void ***, struct x1f4_trans_type *,
     struct x1f4_iturn_type *, struct x1f4_cturn_type *,
     struct x1f4_track_type *, const struct x1f4_eelookup_type *);
extern int _libx1f4i0_lxcall_side_line
    (void *, unsigned, const void *, struct x1f4_linetext_type *, void **,
     unsigned, const struct line_type *);
extern int _libx1f4i0_lxcall_slip_call
    (void **, const struct x1f4_function_type *, unsigned,
     struct x1f4_linetext_type **, struct x1f4_linetext_type *, void **);
extern int _libx1f4i0_lxcall_zero_line(struct x1f4_linetext_type *);

#endif				/* __LIBx1f4_lxcall_H__ */
