/*
 * lxline-inter.h
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxline_inter_H__
#define __LIBx1f4_lxline_inter_H__

#include <lxline-config.h>

#include <cl.h>
#include <dt.h>
#include <e4.h>
#include <lxline-types.h>
#include <lxwide.h>
#include <nt.h>
#include <trans.h>

#define _libx1f4i0_lxline_bset_line	x1f4_bset_lxline
#define _libx1f4i0_lxline_cfix_line	x1f4_cfix_lxline
#define _libx1f4i0_lxline_clip_line	x1f4_clip_lxline
#define _libx1f4i0_lxline_copy_line	x1f4_copy_lxline
#define _libx1f4i0_lxline_deck_line	x1f4_deck_lxline
#define _libx1f4i0_lxline_dset_line	x1f4_dset_lxline
#define _libx1f4i0_lxline_dump_line	x1f4_dump_lxline
#define _libx1f4i0_lxline_fini_line	x1f4_fini_lxline
#define _libx1f4i0_lxline_flat_line	x1f4_flat_lxline
#define _libx1f4i0_lxline_free_line	x1f4_free_lxline
#define _libx1f4i0_lxline_fset_line	x1f4_fset_lxline
#define _libx1f4i0_lxline_hash_line	x1f4_hash_lxline
#define _libx1f4i0_lxline_init_line	x1f4_init_lxline
#define _libx1f4i0_lxline_lead_line	x1f4_lead_lxline
#define _libx1f4i0_lxline_line_line	x1f4_line_lxline
#define _libx1f4i0_lxline_link_line	x1f4_link_lxline
#define _libx1f4i0_lxline_move_line	x1f4_move_lxline
#define _libx1f4i0_lxline_miss_line	x1f4_miss_lxline
#define _libx1f4i0_lxline_near_line	x1f4_near_lxline
#define _libx1f4i0_lxline_node_line	x1f4_node_lxline
#define _libx1f4i0_lxline_pick_line	x1f4_pick_lxline
#define _libx1f4i0_lxline_post_line	x1f4_post_lxline
#define _libx1f4i0_lxline_pull_line	x1f4_pull_lxline
#define _libx1f4i0_lxline_push_line	x1f4_push_lxline
#define _libx1f4i0_lxline_seek_line	x1f4_seek_lxline
#define _libx1f4i0_lxline_slip_line	x1f4_slip_lxline
#define _libx1f4i0_lxline_tile_line	x1f4_tile_lxline
#define _libx1f4i0_lxline_type_line	x1f4_type_lxline
#define _libx1f4i0_lxline_vset_line	x1f4_vset_lxline

extern int _libx1f4i0_lxline_a_break_b(void *, void *, void **);
extern int _libx1f4i0_lxline_a_break_m(void *, void *, void **);
extern int _libx1f4i0_lxline_a_break_r(void *, void *, void **);
extern int _libx1f4i0_lxline_a_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_a_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_a_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_a_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_a_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_a_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_a_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_a_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_b_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_b_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_b_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_b_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_b_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_b_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_b_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_b_sequent(void *, void *, void **);
extern int _libx1f4i0_lxline_bset_line
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxline_c_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_c_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_c_pending(void *, void *, void **);
extern int _libx1f4i0_lxline_c_sequent(void *, void *, void **);
extern int _libx1f4i0_lxline_cfix_line(void *, unsigned, void *);
extern int _libx1f4i0_lxline_clip_line
    (const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxline_copy_link(void *, void *, const void *);
extern int _libx1f4i0_lxline_copy_line
    (void *, void *, void **, const void *, const struct excase_type *);
extern int _libx1f4i0_lxline_copy_text
    (void *, void *, void **, const void *, const struct excase_type *);
extern int _libx1f4i0_lxline_d_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_d_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_d_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_d_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_d_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_d_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_d_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_d_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_d_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_d_pending(void *, void *, void **);
extern int _libx1f4i0_lxline_d_sequent(void *, void *, void **);
extern int _libx1f4i0_lxline_down_line(void *, void *, void *);
extern int _libx1f4i0_lxline_dset_line
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxline_dump_line(void *, struct excase_type *);
extern int _libx1f4i0_lxline_e1centric(void *, void *, void **);
extern int _libx1f4i0_lxline_e1derived(void *, void *, void **);
extern int _libx1f4i0_lxline_e_centric(void *, void *, void **);
extern int _libx1f4i0_lxline_e_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_e_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_e_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_e_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_e_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_e_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_e_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_e_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_f1centric(void *, void *, void **);
extern int _libx1f4i0_lxline_f_centric(void *, void *, void **);
extern int _libx1f4i0_lxline_f_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_f_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_f_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_f_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_f_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_f_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_f_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_f_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_fast_line(void *, void *);
extern int _libx1f4i0_lxline_fine_data(void *, void *, const void *);
extern int _libx1f4i0_lxline_fine_line(void *, void *);
extern int _libx1f4i0_lxline_fini_line(void **);
extern int _libx1f4i0_lxline_flat_line(void *, void **);
extern int _libx1f4i0_lxline_flat_text(void *, void **);
extern int _libx1f4i0_lxline_free_link(void *, void *);
extern int _libx1f4i0_lxline_free_line
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxline_free_text
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxline_fset_line
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxline_g1derived(void *, void *, void **);
extern int _libx1f4i0_lxline_g_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_g_pending(void *, void *, void **);
extern int _libx1f4i0_lxline_h_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_h_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_h_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_h_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_h_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_h_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_h_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_h_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_hash_line
    (void *, struct excase_type **, struct excase_type *);
extern int _libx1f4i0_lxline_heap_line(void *, struct excase_type **, void *);
extern int _libx1f4i0_lxline_i_pending(void *, void *, void **);
extern int _libx1f4i0_lxline_init_line
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxline_j_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_j_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_j_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_j_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_k_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_k_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_l_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_l_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_l_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_l_pending(void *, void *, void **);
extern int _libx1f4i0_lxline_l_sequent(void *, void *, void **);
extern int _libx1f4i0_lxline_late_line
    (void *, void *, void *, const void *);
extern int _libx1f4i0_lxline_lead_line(void *, void **);
extern int _libx1f4i0_lxline_lead_text(void *, void **);
extern int _libx1f4i0_lxline_line_line(void *, void **);
extern int _libx1f4i0_lxline_link_line(void *, void **);
extern int _libx1f4i0_lxline_miss_line
    (void *, void *, const void *, const void *);
extern int _libx1f4i0_lxline_move_line
    (void *, void *, const struct x1f4_nodelink_type *,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxline_n_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_n_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_near_line(void *);
extern int _libx1f4i0_lxline_node_line
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxline_null_line
    (void *, struct excase_type **, void *);
extern int _libx1f4i0_lxline_p_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_p_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_p_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_p_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_p_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_p_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_p_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_p_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_p_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_p_pending(void *, void *, void **);
extern int _libx1f4i0_lxline_p_sequent(void *, void *, void **);
extern int _libx1f4i0_lxline_pick_line
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxline_post_data(void *, void *, void *);
extern int _libx1f4i0_lxline_post_line
    (void *, void **, const struct excase_type *);
extern int _libx1f4i0_lxline_pull_line
    (void *, void *, void *, const void *, struct trans_type *,
     struct x1f4_caselink_type **);
extern int _libx1f4i0_lxline_push_line
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxline_push_text
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxline_q_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_q_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_q_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_q_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_q_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_q_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_q_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_q_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_r1centric(void *, void *, void **);
extern int _libx1f4i0_lxline_r_centric(void *, void *, void **);
extern int _libx1f4i0_lxline_r_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_r_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_r_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_r_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_r_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_r_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_r_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_r_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_r_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_s_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_s_pending(void *, void *, void **);
extern int _libx1f4i0_lxline_s_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_seek_line(const void *);
extern int _libx1f4i0_lxline_side_line(void *, void *);
extern int _libx1f4i0_lxline_size_link(void *, unsigned *, const void *);
extern int _libx1f4i0_lxline_slip_line(void *, void **);
extern int _libx1f4i0_lxline_slip_text(void *, void **);
extern int _libx1f4i0_lxline_spin_line(void *, void *, void *);
extern int _libx1f4i0_lxline_stat_ends(void *, int,  unsigned, unsigned);
extern int _libx1f4i0_lxline_stat_even(void *);
extern int _libx1f4i0_lxline_stat_ever(void *);
extern int _libx1f4i0_lxline_stat_flat(void *, const char *);
extern int _libx1f4i0_lxline_stat_free(void *);
extern int _libx1f4i0_lxline_stat_lead(void *, unsigned);
extern int _libx1f4i0_lxline_stat_link(void *);
extern int _libx1f4i0_lxline_stat_line(void *, int);
extern int _libx1f4i0_lxline_stat_lock(void *, int);
extern int _libx1f4i0_lxline_stat_miss(void *, const char *);
extern int _libx1f4i0_lxline_stat_mode(void *);
extern int _libx1f4i0_lxline_stat_null(void *);
extern int _libx1f4i0_lxline_stat_odds(void *);
extern int _libx1f4i0_lxline_stat_post(void *, const char *);
extern int _libx1f4i0_lxline_stat_text(void *, int, const char *);
extern int _libx1f4i0_lxline_stat_type
    (void *, const char *,  unsigned, unsigned);
extern int _libx1f4i0_lxline_swap_line(void *, void *);
extern int _libx1f4i0_lxline_t1centric(void *, void *, void **);
extern int _libx1f4i0_lxline_t_centric(void *, void *, void **);
extern int _libx1f4i0_lxline_t_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_t_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_t_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_t_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_t_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_t_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_t_derived(void *, void *, void **);
extern int _libx1f4i0_lxline_t_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_t_pending(void *, void *, void **);
extern int _libx1f4i0_lxline_tile_line
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxline_type_line(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxline_v_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_v_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_v_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_v_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_v_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_v_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_v_logique(void *, void *, void **);
extern int _libx1f4i0_lxline_vset_line(void *, void **);
extern int _libx1f4i0_lxline_u_forward(void *, void *, void **);
extern int _libx1f4i0_lxline_x_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_x_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_x_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_x_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_x_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_x_class_v(void *, void *, void **);
extern int _libx1f4i0_lxline_z_class_b(void *, void *, void **);
extern int _libx1f4i0_lxline_z_class_m(void *, void *, void **);
extern int _libx1f4i0_lxline_z_class_r(void *, void *, void **);
extern int _libx1f4i0_lxline_z_class_t(void *, void *, void **);
extern int _libx1f4i0_lxline_z_class_u(void *, void *, void **);
extern int _libx1f4i0_lxline_z_class_v(void *, void *, void **);

#endif				/* __LIBx1f4_lxline_inter_H__ */
