/*
 * lxlist-f.t.c
 * Copyright (C) 2008, 2009, 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxlist_t_forward(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxlist_type *lxlist_data;

    dxlist_data = I_LIST(input[0]);

    lxlist_data = context;

    if (!dxlist_data->size) {
	status = _libx1f4i0_lxlist_stat_null(lxlist_data);
    } else {
	void *data;

	status = _libx1f4i0_ever_l4list(dxlist_data->list, &data);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_list(context, status);
	} else {
	    status = _libx1f4i0_lxlist_fine_data(context, output, data);
	}
    }

    return status;
}
